﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private tv1 As TreeView
	Private imgfolder As Image
	Private imgfile As Image
	Public rootpath As String
	Private brcr1 As B4XBreadCrumb
	Public brcrlst As List
	Private cbx1 As B4XComboBox
	Private sh As Shell
	Private ta1 As TextArea
	Private ziv1 As ZoomImageView
	Private sp1 As ScrollPane
	Public pnpdf As Pane
	Public joswing As JavaObject
	Public jofile As JavaObject
	Public joPDDocument As JavaObject
	Public jopdfdoc As JavaObject
	Public jorenderer As JavaObject
	Public joscreen As JavaObject
	Public dpi As Float
	Public pdffile As String
	Private numpages As Int
	Public ivpdf As ImageView
	Private zoom As Float
	Private img As Object
	Private sppagepdf As ScrollPane
	Public pnpagepdf As Pane
	Public allpages_available As Boolean
	Private wv1 As WebView
	Private lblattrib As Label
	Private btninfo As Button
	Private hclass As htmlclass
	Private btnsave As Button
	Public fchoose As FileChooser
	Private tfsearch As TextField
	Private mv1 As MediaView
	Private mvc1 As MediaViewController
	Private btnrotate As Button
	Private btnsize As Button
	Private bsb1 As B4XSeekBar
	Private lblvolume As Label
	Private btnweb As Button
	Private wv2 As WebView
	Private clv1 As CustomListView
	Private lbldata As Label
	Private lblkey As Label
	Private infodialog As B4XDialog
	Private ftfpage As B4XFloatTextField
	Private lblpages As Label
	Private pagenumber As Int
	Private playlist As List
	Private playingpath As String
	Private playingfile As String
	Private bsbpdf As B4XSeekBar
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"pmfiles")
	hclass.Initialize
	fchoose.Initialize
	playlist.Initialize
	xui.SetDataFolder("pmfiles")
	File.Copy(File.DirAssets,"convert_word_to_pdf.ps1",xui.DefaultFolder,"convert_word_to_pdf.ps1")
	File.Copy(File.DirAssets,"convert_excel_to_pdf.ps1",xui.DefaultFolder,"convert_excel_to_pdf.ps1")
	File.Copy(File.DirAssets,"convert_powerpoint_to_pdf.ps1",xui.DefaultFolder,"convert_powerpoint_to_pdf.ps1")
	imgfolder.InitializeSample(File.DirAssets, "folder.png",30dip,30dip)
	imgfile.InitializeSample(File.DirAssets, "file.png",30dip,30dip)
	fill_cbx1
	rootpath = cbx1.SelectedItem
	brcrlst.Initialize
	brcrlst.Add(rootpath)
	brcr1.Items.Clear
	brcr1.Items = brcrlst
	fill_tv1(rootpath)
	infodialog.Initialize(Root)
	infodialog.PutAtTop = True
	infodialog.BackgroundColor = xui.Color_LightGray
	reset_views
	zoom = bsbpdf.Value/100
End Sub
Private Sub fill_cbx1
	Dim jo As JavaObject
	Dim o() As Object = jo.InitializeStatic("java.io.File").RunMethod("listRoots", Null)
	Dim lst As List = o
	cbx1.SetItems(lst)	
End Sub
Private Sub cbx1_SelectedIndexChanged (Index As Int)
	fill_cbx1
	reset_views
	rootpath = cbx1.GetItem(Index)
	cbx1.SelectedIndex = Index
	brcrlst.Initialize
	brcrlst.Add(rootpath)
'	Log("drive change: " & brcrlst)
'	brcr1.Items.Clear
	brcr1.Items = brcrlst
	fill_tv1(rootpath)
	reset_views
	get_attrib_list(rootpath,"")
	tfsearch.RequestFocus
	tfsearch.Text = ""
End Sub
Private Sub fill_tv1(rootfldr As String)
	playlist.Clear
	tv1.Root.Children.Clear
	If File.Exists(rootfldr,"") = False Then Return
	Dim lst As List = File.ListFiles(rootfldr)
	If lst.IsInitialized Then
		If lst.Size < 1 Then Return
'		Log("rootfldr list: " & lst)
'		Log("rootfldr: " & rootfldr)
		For i = 0 To lst.Size -1
			Dim f As String = lst.Get(i)
			If File.IsDirectory(rootfldr, f) Then
				Dim ti As TreeItem
				ti.Initialize("ti",lst.Get(i))
				ti = add_children(ti,rootfldr & ti.Text)
				ti.Image = imgfolder
				tv1.Root.Children.Add(ti)
			Else
				Dim cti As TreeItem
				cti.Initialize("",lst.Get(i))
				cti.Image = imgfile
				tv1.Root.Children.Add(cti)
				Dim stritem As String = lst.Get(i)
				If stritem.EndsWith(".mp3") Or stritem.EndsWith(".mp4") Or stritem.EndsWith(".wav") Then
					playlist.Add(rootpath & "\" & stritem)
				End If
			End If
		Next
	End If
	Log(playlist)
End Sub
Private Sub add_children(pti As TreeItem, dir As String) As TreeItem
	Dim newpti As TreeItem
	newpti.Initialize("ti",pti.Text)
'	Log(pti.Text)
'	Log(dir)
	Dim lst As List = File.ListFiles(dir)
	If lst.IsInitialized Then
		For i = 0 To lst.Size -1
			Dim ti As TreeItem
			ti.Initialize("ti",lst.Get(i))
			If File.IsDirectory(dir, lst.Get(i)) Then
'				ti = add_children(ti,dir & "/" & ti.Text)
				ti.Image = imgfolder
			Else
				ti.Image = imgfile
			End If
			newpti.Children.Add(ti)
		Next
	End If
	Return newpti
End Sub
Private Sub tv1_SelectedItemChanged (SelectedItem As TreeItem)
	If tv1.IsInitialized Then
		If SelectedItem.IsInitialized Then
			reset_views
			Dim item As TreeItem = SelectedItem
'			Log("selected: " & rootpath)
'			Log("selected: " & item.Text)
			set_rootpath
			If File.IsDirectory(rootpath,item.Text) = True Then
				If item.Text.EndsWith("\") = False Then
					rootpath = rootpath & item.Text & "\"
				End If
'				Log("fill rootpath: " & rootpath)			
				fill_tv1(rootpath)
				brcrlst.Add(item.text)
				brcr1.Items = brcrlst
'				get_attrib_list(rootpath,"")
			Else
'				Log("rootpath: " & rootpath)
'				Log("item text: " & item.Text)
'				Log("parent: " & item.Parent)
				If item.Parent.Text = "root" Then
					get_attrib_list(rootpath,item.text)
					show_selected_file_content(rootpath & item.text)
				Else
					xui.MsgboxAsync("Select a file from the opened parent folder: " & item.parent.text,"Parent Folder")
					tv1_SelectedItemChanged(item.Parent)
				End If
			End If
		End If
	End If
End Sub
Private Sub brcr1_CrumbClick (Crumbs As List)
	brcr1.Items = Crumbs
	brcrlst = Crumbs
	set_rootpath
	fill_tv1(rootpath)
	reset_views
	get_attrib_list(rootpath,"")
End Sub
Private Sub reset_views
	ta1.Text = ""
	lblattrib.Text = ""
	ziv1.mBase.Visible = False
	btnrotate.Visible = False
	btnsize.Visible = False
	sp1.Visible = False
	sppagepdf.Visible = False
	wv1.Visible = False
	wv1.LoadHtml("")
	btnweb.Visible = False
	ftfpage.mBase.Visible = False
	lblpages.Visible = False
	bsbpdf.mBase.Visible = False
	If File.Exists(xui.DefaultFolder,"file_info.txt") Then
		File.Delete(xui.DefaultFolder,"file_info.txt")
	End If
End Sub
Private Sub set_rootpath
	rootpath = ""
'	Log("rootpath list: " & brcrlst)
	For i = 0 To brcrlst.Size -1
		rootpath = rootpath & brcrlst.Get(i)
		If rootpath.EndsWith("\") = False Then
			rootpath = rootpath & "\"
		End If
	Next
'	Log("set_rootpath: " & rootpath)
End Sub
Private Sub get_attrib_list(path As String, fname As String)
	Dim attribinfo As String = "  (A = archive, H = hidden, I = not indexed, R = read-only, S = system, X = no scrub, V = integrity)"
	Try
		Dim sh As Shell
		If fname = "" Then
			Dim strparam As String = "/C attrib """ & path & "*.*" & """ >output.txt"
		Else
			Dim strparam As String = "/C attrib """ & path & fname & """ >output.txt"
		End If
		Dim args As List = Array(strparam)
		sh.InitializeDoNotHandleQuotes("shl", "cmd.exe", args)
		sh.WorkingDirectory = xui.DefaultFolder
		sh.RunSynchronous(-1)			' the process must complete
		Dim stroutput As String = File.ReadString(xui.DefaultFolder,"output.txt")
		If stroutput.Contains("File not found") = False Then
			Dim flst As List = Regex.Split(CRLF,stroutput)
			For i = 0 To flst.Size -1
				Dim fline As String = flst.Get(i)
				Dim attribs As String = fline.SubString2(0,13)
'			Dim fpath As String = fline.SubString(13)
				Dim ffile As String = fline.SubString(fline.LastIndexOf("\")+1)
				If flst.Size < 2 Then
					lblattrib.Text = "  " & attribs & ffile & CRLF & attribinfo
					get_file_info(path,fname)
				Else
					lblattrib.Text = ""
				End If
			Next
		End If		
	Catch
		Log(LastException)
	End Try
End Sub
Private Sub show_selected_file_content(filename As String)
'	Log("filename: " & filename)
	Dim item As String = filename
	Dim fname As String = item.SubString(item.LastIndexOf("\")+1).Trim
	Dim fpath As String = item.SubString2(0,item.LastIndexOf("\")+1).Trim
	Dim ext As String = fname.SubString(fname.LastIndexOf(".")+1).Trim
	btnsave.Tag = ""
	btnrotate.Tag = ""
	btnsize.Tag = ""
'	Log(fname)
'	Log(ext)
	Try
		Select ext.ToLowerCase
			Case "mp3","mp4","wav"
				show_mv1
				play_sound(fpath,fname)
			Case "jpg","png","jpeg","gif","bmp"
				Dim im As Image
				im.Initialize(fpath,fname)
				show_ziv1
				ziv1.SetBitmap(im)
				Dim imleft As Int = 10
				Dim imtop As Int = 10
				If im.Width < 150 Then imleft = 200
				If im.Height < 150 Then imtop = 200
				If im.Width < 150 And im.Height < 150 Then
					ziv1.ImageView.SetLayoutAnimated(0,imleft,imtop,im.Width,im.Height)					
				End If
				btnrotate.Tag = filename
				btnsize.Tag = filename
			Case "doc","docx","xls","xlsx","ppt","pptx"
				Dim caption As String = "Convert MSOffice file to PDF. Continue?" & CRLF & _
						"The conversion will take some time" & CRLF & "depending on the size of the File." & CRLF & _
						"An existing PDF file with the same name will be replaced!" & CRLF
				Dim answ As Object = xui.Msgbox2Async(caption, "Convert to PDF file", "Yes", "Cancel", "No", Null)
				Wait For (answ) Msgbox_Result (Result As Int)
				If Result = xui.DialogResponse_Positive Then
					convert_to_pdf(fpath,fname,ext.ToLowerCase)
					pdffile = item.SubString2(0,item.LastIndexOf(".")) & ".pdf"
					If File.Exists(fpath,fname.SubString2(0,fname.LastIndexOf(".")) & ".pdf") = True Then
						show_sppagepdf
						initpage
						renderpage(1)
					Else
						show_ta1
						ta1.Text = "There was no PDF file created." & CRLF & _
								"The file name probably contains special characters." & CRLF
					End If
				End If
			Case "pdf"
	'			show_sp1
				show_sppagepdf
				pdffile = item.Trim
				initpage
				renderpage(1)
	'			renderallpages
			Case "txt","log","ini","bat","csv","meta"
				show_ta1
				Dim strtext As String = File.ReadString(fpath.Trim,fname.Trim)
				ta1.Text = strtext
				btnsave.Tag = filename
'			Case "htm","html"
'				show_wv1
'				Dim strtext As String = File.ReadString(fpath.Trim,fname.Trim)
'				wv1.LoadHtml(strtext)
'				wv1.Zoom = 0.8
			Case "html","htm","css","js","bas","b4a","b4i","b4j","vb","php","xml","json","sql","java","vbs","ps1","cs"
				show_wv1
				Dim strtext As String = File.ReadString(fpath.Trim,fname.Trim)
				If strtext.IndexOf("codemirror.js") <> -1 Then
					If strtext.IndexOf("textarea") <> -1 Then
						strtext = strtext.Replace("textarea","div")	' to display the codemirror settings
						xui.MsgboxAsync("<textarea id='editor'> and </textarea> was changed to show the codemirror code!","Codemirror")
					End If
				End If
				Dim mode As String = set_editor_mode(ext)
				Dim htmlstring As String = hclass.set_htmlpage(strtext,mode,"eclipse")
				wv1.LoadHtml(htmlstring)
				btnsave.Tag = filename
				If ext.ToLowerCase = "html" Or ext.ToLowerCase = "htm" Then
					btnweb.Visible = True
					btnweb.Text = "Webpage"
					btnweb.Tag = filename
				Else
					btnweb.Tag = ""
					btnweb.Visible = False	
				End If
			Case "sys","exe","com","dll"
				show_ta1
				ta1.Text = CRLF & "No viewer available for this file."
			Case Else
				show_ta1
				ta1.Text = CRLF & "No viewer available for this file."
		End Select
	Catch
		Log(LastException)
		show_ta1
		ta1.Text = "There was an error accessing this file." & CRLF & _
				   "Maybe access to this file is denied." & CRLF & _
				   "Or the path and filename may include illegal characters."
	End Try
End Sub
Private Sub set_editor_mode(extention As String) As String
	Dim mode As String
	Select extention
		Case "bas","b4a","b4i","b4j"
			mode = "b4x"
		Case "vb","vbs"
			mode = "vb"
		Case "java"
			mode = "java"
		Case "js","json","cs"
			mode = "javascript"
		Case "php"
			mode = "php"
		Case "sql"
			mode = "sql"
		Case "css"
			mode = "css"
		Case "xml"
			mode = "xml"
		Case "html","htm"
			mode = "htmlmixed"
		Case "ps1"
			mode = "text"
	End Select
	Return mode
End Sub
Private Sub show_ta1
	ta1.Visible = True
	ziv1.mBase.Visible = False
	sp1.Visible = False
	sppagepdf.Visible = False
	wv1.Visible = False
	mv1.mBase.Visible = False
	mvc1.mBase.Visible = False
	btnrotate.Visible = False
	btnsize.Visible = False
	bsb1.mBase.Visible = False
	lblvolume.Visible = False
	wv2.Visible = False
	btnweb.Visible = False
	ftfpage.mBase.Visible = False
	lblpages.Visible = False
	bsbpdf.mBase.Visible = False
End Sub
Private Sub show_mv1
	ta1.Visible = False
	ziv1.mBase.Visible = False
	sp1.Visible = False
	sppagepdf.Visible = False
	wv1.Visible = False
	mv1.mBase.Visible = True
	mvc1.mBase.Visible = True
	btnrotate.Visible = False
	btnsize.Visible = False
	bsb1.mBase.Visible = True
	lblvolume.Visible = True
	wv2.Visible = False
	btnweb.Visible = False
	ftfpage.mBase.Visible = False
	lblpages.Visible = False
	bsbpdf.mBase.Visible = False
End Sub
Private Sub show_ziv1
	ta1.Visible = False
	ziv1.mBase.Visible = True
	sp1.Visible = False
	sppagepdf.Visible = False
	wv1.Visible = False
	mv1.mBase.Visible = False
	mvc1.mBase.Visible = False
	btnrotate.Visible = True
	btnsize.Visible = True
	bsb1.mBase.Visible = False
	lblvolume.Visible = False
	wv2.Visible = False
	btnweb.Visible = False
	ftfpage.mBase.Visible = False
	lblpages.Visible = False
	bsbpdf.mBase.Visible = False
End Sub
Private Sub show_wv1
	ta1.Visible = False
	ziv1.mBase.Visible = False
	sp1.Visible = False
	sppagepdf.Visible = False
	wv1.Visible = True
	mv1.mBase.Visible = False
	mvc1.mBase.Visible = False
	btnrotate.Visible = False
	btnsize.Visible = False
	bsb1.mBase.Visible = False
	lblvolume.Visible = False
	wv2.Visible = False
	btnweb.Visible = False
	ftfpage.mBase.Visible = False
	lblpages.Visible = False
	bsbpdf.mBase.Visible = False
End Sub
Private Sub show_sp1
	ta1.Visible = False
	ziv1.mBase.Visible = False
	sp1.Visible = True
	sppagepdf.Visible = False
	wv1.Visible = False
	mv1.mBase.Visible = False
	mvc1.mBase.Visible = False
	btnrotate.Visible = False
	btnsize.Visible = False
	bsb1.mBase.Visible = False
	lblvolume.Visible = False
	wv2.Visible = False
	btnweb.Visible = False
	ftfpage.mBase.Visible = True
	lblpages.Visible = True
	bsbpdf.mBase.Visible = True
End Sub
Private Sub show_sppagepdf
	ta1.Visible = False
	ziv1.mBase.Visible = False
	sp1.Visible = False
	sppagepdf.Visible = True
	wv1.Visible = False
	mv1.mBase.Visible = False
	mvc1.mBase.Visible = False
	btnrotate.Visible = False
	btnsize.Visible = False
	bsb1.mBase.Visible = False
	lblvolume.Visible = False
	wv2.Visible = False
	btnweb.Visible = False
	ftfpage.mBase.Visible = True
	lblpages.Visible = True
	bsbpdf.mBase.Visible = True
End Sub
Private Sub initpage
	If jopdfdoc.IsInitialized Then
		jopdfdoc.RunMethod("close",Null)
	End If
	allpages_available = False
	joswing.InitializeStatic("javafx.embed.swing.SwingFXUtils")
	jofile.InitializeNewInstance("java.io.File",Array(pdffile))
	joPDDocument.InitializeStatic("org.apache.pdfbox.pdmodel.PDDocument")
	jopdfdoc = joPDDocument.RunMethod("load",Array(jofile))
	jorenderer.InitializeNewInstance("org.apache.pdfbox.rendering.PDFRenderer",Array(jopdfdoc))
	dpi = joscreen.InitializeStatic("javafx.stage.Screen").RunMethodJO("getPrimary",Null).RunMethod("getDpi",Null)
	numpages = jopdfdoc.RunMethod("getNumberOfPages",Array())
	ivpdf.Initialize("")
	pnpdf.Initialize("")
	pnpagepdf.Initialize("")
	lblpages.Text = " Total pages: " & numpages
	ftfpage.Text = ""
End Sub
Private Sub renderpage(pnum As Int)
	img = jorenderer.RunMethod("renderImageWithDPI",Array(pnum-1,dpi*zoom))
	ivpdf.SetImage(joswing.RunMethodjo("toFXImage",Array(img,Null)))
	pnpagepdf.RemoveAllNodes
	pnpagepdf.AddNode(ivpdf,10,0,ivpdf.Width,ivpdf.Height)
	sppagepdf.InnerNode = pnpagepdf
	sppagepdf.InnerNode.PrefHeight = 1185dip * zoom
	sppagepdf.VPosition = 0
End Sub
Private Sub renderallpages
	If allpages_available = True Then
		Return
	End If
	pnpdf.RemoveAllNodes
	lblpages.Text = " Total pages: " & numpages
	Dim toppos As Int = 0
	For i = 0 To numpages - 1
		img = jorenderer.RunMethod("renderImageWithDPI",Array(i,dpi*zoom))
		Dim iv As ImageView
		iv.Initialize("")
		iv.SetImage(joswing.RunMethodjo("toFXImage",Array(img,Null)))
		pnpdf.AddNode(iv,10,toppos,iv.Width,iv.Height)
		toppos = toppos + (1185dip * zoom)
	Next
	sp1.InnerNode = pnpdf
	sp1.InnerNode.PrefHeight = 1185dip * zoom * numpages
	sp1.VPosition = 0
	allpages_available = True
	Sleep(0)
End Sub
Private Sub sppagepdf_MouseClicked (EventData As MouseEvent)
	Dim caption As String = "Show all pages?" & CRLF & _
							"This will take some time to load depending on the size of the document." & CRLF
	Dim answ As Object = xui.Msgbox2Async(caption, "PDF file", "Yes", "Cancel", "No", Null)
	Wait For (answ) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		If jofile.IsInitialized Then
			show_sp1
			initpage
			renderallpages
			If allpages_available = True Then
				xui.MsgboxAsync("All pages are available." & CRLF & "You can now scroll through the document.","PDF file")
			End If
		End If
	End If
End Sub
Private Sub btninfo_Click
	If File.Exists(xui.DefaultFolder,"file_info.txt") Then
		Dim stroutput As String = File.ReadString(xui.DefaultFolder,"file_info.txt")
		stroutput = stroutput.Replace(Chr(13),"")
		If stroutput <> "" Then
			Dim info As String = stroutput.SubString(2)
'			xui.MsgboxAsync(info.Trim,"File info")
			show_infodialog(info.Trim)
		Else
			show_ta1
			ta1.Text = "There was no file_info file created." & CRLF & _
						"The file name probably contains special characters." & CRLF
		End If
	End If
End Sub
Private Sub show_infodialog(strinfo As String)
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.LoadLayout("infodialog_layout")
	pnl.SetLayoutAnimated(0dip,0,0,1000,600)
	Dim lst As List = Regex.Split(CRLF,strinfo)
	clv1.Clear
	For i = 0 To lst.Size -1
		Dim item As String = lst.Get(i)
		Dim strkey As String = item.SubString2(0,item.IndexOf("=")).Trim
		Dim strdata As String = item.SubString(item.IndexOf("=")+1).Trim
		If item.StartsWith("CreationDate") Or item.StartsWith("InstallDate") Or item.StartsWith("LastAccessed") Or item.StartsWith("LastModified") Then
			Dim strdate As String = strdata.SubString2(0,8)
			Dim strtime As String = strdata.SubString2(8,14)
			strdata = strdate.SubString2(0,4) & "-" & strdate.SubString2(4,6) & "-" & strdate.SubString2(6,8) & _
					  " " & strtime.SubString2(0,2) & ":" & strtime.SubString2(2,4) & ":" & strtime.SubString2(4,6)
		End If
		Dim pn As Pane = set_infoitem(strkey,strdata)
		clv1.Add(pn,i)
	Next
	Dim rsinfo As ResumableSub =  infodialog.ShowCustom(pnl, "OK", "", "")
	Wait For (rsinfo) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		'
	End If
End Sub
Private Sub set_infoitem(key As String, data As String) As Pane
	Dim pn As Pane
	pn.Initialize("")
	pn.LoadLayout("clv1item_layout")
	pn.SetLayoutAnimated(0dip,0,0,1000,50)
	lblkey.Text = key & ": "
	lbldata.Text = " " & data
	Return pn
End Sub
Private Sub get_file_info(path As String, fname As String)
	Dim strspec As String = " -+(){}[]&@#§!^$%=;,"	' avoid using these characters in filenames!
	For i = 0 To strspec.Length -1
		If fname.Contains("""" & strspec.CharAt(i) & """") Then
			show_ta1
			ta1.Text = "There was no file_info file created." & CRLF & _
						"The file name probably contains special characters." & CRLF
			Return			
		End If
	Next
	Try
		path = path.Replace("\","\\")
		Dim sh As Shell
		If fname <> "" Then
			'https://stackoverflow.com/questions/55310573/wmic-command-in-batch-outputting-non-utf-8-text-files
			Dim strparam As String = "/C wmic datafile where Name=""" & path & fname & """ list /format:list | find /v """" >" & xui.DefaultFolder & "\file_info.txt"
		End If
		Log(strparam)
		Dim args As List = Array(strparam)
		sh.InitializeDoNotHandleQuotes("shl", "cmd.exe", args)
		sh.WorkingDirectory = xui.DefaultFolder
		sh.RunSynchronous(-1)			' the process must complete
	Catch
		Log(LastException)
		show_ta1
		ta1.Text = "There was an error accessing this file. Probably access is denied."
	End Try
End Sub
Private Sub btnsave_Click
	Dim btn As Button = Sender
	If btn.Tag <> "" Then
		Dim savedfile As String = save_file(btn.tag)
		If savedfile <> "" Then
			xui.MsgboxAsync(savedfile & " is saved.","Save file")
		Else
			xui.MsgboxAsync("Save file was cancelled!","Save file")
		End If		
	End If
End Sub
Private Sub save_file(tag As String) As String
	fchoose.InitialDirectory = tag.SubString2(0,tag.LastIndexOf("\"))
	fchoose.InitialFileName = tag.SubString(tag.LastIndexOf("\")+1)
	Dim fname As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If fname = "" Then Return fname
	Dim filepath As String = fname.SubString2(0,fname.LastIndexOf("\"))
	Dim filename As String = fname.SubString(fname.LastIndexOf("\")+1)
	If ta1.Text <> "" Then
		Try
			File.WriteString(filepath,filename,ta1.Text)
			Return fname			
		Catch
			Log(LastException)
			show_ta1
			ta1.Text = "There was an error saving this file. Probably access is denied."
			Return ""
		End Try
	Else
		' codemirror editor text
		Dim jo As JavaObject = wv1
		Dim stredit As String = jo.RunMethodJO("getEngine", Null).RunMethod("executeScript", Array("editor.getValue();"))
		Try
			File.WriteString(filepath,filename,stredit)
			Return fname
		Catch
			Log(LastException)
			show_ta1
			ta1.Text = "There was an error saving this file. Probably access is denied."
			Return ""
		End Try
	End If
End Sub
Private Sub tfsearch_Action
	Dim lst As List = tv1.Root.Children
	For i = 0 To lst.Size -1
		Dim ti As TreeItem = lst.Get(i)
		If ti.Text.ToUpperCase.StartsWith(tfsearch.Text.ToUpperCase) Then
			tv1_SelectedItemChanged (ti)
			Return
		End If
	Next
End Sub
Private Sub play_sound(ppath As String, pfname As String)
	If File.Exists(ppath,pfname) Then
		playingpath = ppath
		playingfile = pfname
		ppath = ppath.Replace("\","/")
		Dim lstints As List = Array(32,91,93,35)
		Dim lsthexs As List = Array("20","5B","5D","23")
		For i = 0 To lstints.Size -1
			Dim intchr As Int = lstints.Get(i)
			If ppath.Contains(Chr(intchr)) Then
				ppath = ppath.Replace(Chr(intchr),"%" & lsthexs.Get(i))
			End If
			If pfname.Contains(Chr(intchr)) Then
				pfname = pfname.Replace(Chr(intchr),"%" & lsthexs.Get(i))
			End If
		Next
		Try
			mvc1.SetMediaView(mv1)
			mv1.Source = "file:///" & ppath & pfname
			mv1.Volume = bsb1.Value / 100
			mvc1.FadeAfterMs = 1000000000
			Sleep(1000)
			mv1.Play			
		Catch
			Log(LastException)
			show_ta1
			ta1.Text = "This file cannot be played. Probably the filename contains a special character."
		End Try
	End If		
End Sub
Private Sub mv1_Complete
'	Log("end of playing... " & playingpath & "\\" & playingfile)
	If playlist.Size > 0 Then
		playingpath = playingpath.Replace("/","\")
		Dim index As Int = playlist.IndexOf(playingpath & "\" & playingfile)
		index = index + 1
'		Log("index: " & index)
		If index <= playlist.Size -1 Then
			Dim strnew As String = playlist.Get(index)
		Else
			index = 0
			Dim strnew As String = playlist.Get(index)
		End If
		playingpath = strnew.SubString2(0,strnew.LastIndexOf("\"))
		playingfile = strnew.SubString(strnew.LastIndexOf("\")+1)
		tv1.ClearSelection
		get_attrib_list(playingpath,playingfile)
'		Log("playing... " & playingpath & "\" & playingfile)
		play_sound(playingpath,playingfile)
	End If
End Sub
Private Sub btnsize_Click
	Dim btn As Button = Sender
	If btn.Tag <> "" Then
		Dim tag As String = btn.Tag
		Dim fpath As String = tag.SubString2(0,tag.LastIndexOf("\"))
		If fpath.EndsWith(":") Then fpath = fpath & "\"
		Dim fname As String = tag.SubString(tag.LastIndexOf("\")+1)
		Dim im As Image
		im.Initialize(fpath,fname)
		ziv1.SetBitmap(im)
		Dim imleft As Int = 10
		Dim imtop As Int = 10
		If im.Width < 150 Then imleft = 200
		If im.Height < 150 Then imtop = 200
		If im.Width < 150 And im.Height < 150 Then
			ziv1.ImageView.SetLayoutAnimated(0,imleft,imtop,200,200)
		End If
	End If
End Sub
Private Sub btnrotate_Click
	Dim btn As Button = Sender
	If btn.Tag <> "" Then
		Dim rotate As Int = ziv1.ImageView.Rotation
		rotate = rotate + 90
		If rotate > 360 Then rotate = 90
		ziv1.ImageView.Rotation = rotate
	End If
End Sub
Private Sub bsb1_ValueChanged (Value As Int)
	mv1.Volume = Value / 100
End Sub
Private Sub mv1_StateChanged (State As String)
	If State = "PLAYING" Then
		bsb1.mBase.Visible = True
		lblvolume.Visible = True
	Else
		bsb1.mBase.Visible = False
		lblvolume.Visible = False
	End If
End Sub
Private Sub btnweb_Click
	Dim btn As Button = Sender
	If btn.Text = "Close" Then
		wv2.Visible = False		
		btn.Text = "Webpage"
		Return
	End If
	If btn.Tag <> "" Then
		Dim tag As String = btn.Tag
		Dim fpath As String = tag.SubString2(0,tag.LastIndexOf("\"))
		If fpath.EndsWith(":") Then fpath = fpath & "\"
		Dim fname As String = tag.SubString(tag.LastIndexOf("\")+1)
		Dim strtext As String = File.ReadString(fpath.Trim,fname.Trim)
		wv2.Visible = True
		wv2.LoadHtml(strtext)
		wv2.Zoom = 0.8
		btn.Text = "Close"
	End If
End Sub
Private Sub convert_to_pdf(fpath As String,fname As String,ext As String)
	'	https://stackoverflow.com/questions/16534292/basic-powershell-batch-convert-word-docx-to-pdf
	If fpath.EndsWith("\") Then fpath = fpath.SubString2(0,fpath.Length-1)
	' powershell uses the backtick character as an escape character (in stead of the backslash \)
	fpath = fpath.Replace("\","`\")		' escape the backslash
	Dim strspec As String = " -+(){}[]&@#§!^$%=;,"	' avoid using these characters in filenames!
	For i = 0 To strspec.Length -1
		fname = fname.Replace(strspec.CharAt(i),"`" & strspec.CharAt(i))
	Next
	Log(fname)
	Select ext
		Case "doc","docx"			
			If fname <> "" Then
				Dim pspath As String = xui.DefaultFolder & "`\convert_word_to_pdf.ps1"
			End If
		Case "xls","xlsx"
			If fname <> "" Then
				Dim pspath As String = xui.DefaultFolder & "`\convert_excel_to_pdf.ps1"
			End If
		Case "ppt","pptx"
			If fname <> "" Then
				Dim pspath As String = xui.DefaultFolder & "`\convert_powerpoint_to_pdf.ps1"
			End If
	End Select
	Try
		Dim sh As Shell
		Dim docpath As String = """" & fpath & """"
		Dim docfilter As String = """" & fname & """"
		Dim strparam As String = pspath & " " & docpath & " " & docfilter
		Dim args As List = Array(strparam)
		sh.InitializeDoNotHandleQuotes("shl", "C:\\WINDOWS\\system32\\WindowsPowerShell\\v1.0\\powershell.exe", args)
		sh.WorkingDirectory = xui.DefaultFolder
		sh.RunSynchronous(-1)
	Catch
		Log(LastException)
		show_ta1
		ta1.Text = "There was an error converting this file." & CRLF
	End Try
End Sub
Private Sub ftfpage_EnterPressed
	If ftfpage.text <> ""  And IsNumber(ftfpage.Text)  Then
		pagenumber = ftfpage.Text
		If (pagenumber < 1 Or pagenumber > numpages) Then
			xui.MsgboxAsync("Pick a number between 1 and " & numpages,"Page number")
		Else
			Dim ph As Int = (1185 * zoom)
			Dim totph As Int = ((1185 * zoom) * numpages) - sp1.PrefHeight
			Dim vpos As Double = ph * (ftfpage.Text -1) / totph
			sp1.VPosition = vpos
			renderpage(pagenumber)
		End If
	End If
End Sub
Private Sub bsbpdf_ValueChanged (Value As Int)
	zoom = Value/100
	If allpages_available = True Then
		initpage
		renderallpages
	Else
		renderpage(1)			
	End If
End Sub